#!/usr/perl5/bin/perl -w
#
# Copyright (c) 2001 by Sun Microsystems, Inc.
# All rights reserved.
#
#pragma ident   "@(#)disk.pl 1.8     01/08/23 SMI"
#
# Return disk data to java applet
#

require 5.005;
use strict;
use lib '/opt/SUNWscvw/lib/perl';
use Cluster::Cgi;
use Cluster::Device;
use Sun::Solaris::Utils qw(gettext);

my $q = new Cluster::Cgi;
print $q->header(-expires => "now");

my $device = new Cluster::Device;
my @node_list = $device->get_nodelist();
my %node_numbers;

my $num_nodes = @node_list;
for (my $count = 0; $count < $num_nodes; $count++) {
	$node_numbers{"$node_list[$count]"} = $count;
}	

my @output = `/usr/cluster/bin/scdidadm -L `;
my $last_entry = 0;

my @disk_list;

for my $pnm (@output) {
	my @entry = split(/\s+/, $pnm);
	if ($last_entry == $entry[0]) {
		my @temp = split(/\//, $entry[2]);
		push(@disk_list, $temp[4]);
	}
	$last_entry = $entry[0];
}

my $disk_count = @disk_list;
print "$disk_count\n";
for my $disk (@disk_list) {
	print "$disk\n";
}

my $length = @output;

for (my $i = 0; $i < $length; $i++) {
	my @list1 = split(/\s+/, $output[$i]);
	my @list2 = split(/\s+/, $output[$i + 1]);
	if ($list1[0] == $list2[0]) {
		my @connection;
		my ($temp_name) = split(/:/, $list1[1]);
		$connection[$node_numbers{$temp_name}] = 1;
		($temp_name) = split(/:/, $list2[1]);
		$connection[$node_numbers{$temp_name}] = 1;

		for (my $j = 0; $j < $num_nodes; $j++) {
			if ($connection[$j]) {
				print "$connection[$j]\n";
			} else {
				print "0\n";
			}
		}
	}
}

