#!/usr/bin/perl -w
#
# Copyright (c) 2001 by Sun Microsystems, Inc.
# All rights reserved.
#
#ident	"@(#)node_status.pl	1.5	01/07/27 SMI"
#
# Node status page
#

require 5.005;
use strict;
use lib '/opt/SUNWscvw/lib/perl';
use Cluster::Cgi;
use Cluster::Node;
use Sun::Solaris::Utils qw(gettext);

# Create the cluster objects
my $q = new Cluster::Cgi;
my $node = new Cluster::Node;

# Print the query header and make the page expire now
print $q->header(-expires => "now");

# Start the document
print $q->start_html({ TITLE => gettext("Node Status"),
		       STYLE  => { 'src' => '/css/clustmgr-style.css'},
		       CLASS  => "default-body",
		       SCRIPT => "top.helpMarker=\"node_status-top\"\n" .
				$q->yoke_jscript("n")
		       });

##############################################################################
#
# Action Bar Table
#
##############################################################################

# Start the action bar table
$q->start_action_bar_table(gettext("Nodes"));

# Print the middle of the action table
$q->mid_action_bar_table();

# End the action bar table
$q->end_action_bar_table();

##############################################################################
#
# Status table for nodes
#
##############################################################################

# Print the node status table
$node->node_status_table($q);
