#!/usr/perl5/bin/perl -w
#
# Copyright (c) 2001 by Sun Microsystems, Inc.
# All rights reserved.
#
#
#pragma ident   "@(#)quorum_add.pl 1.7     01/07/27 SMI"
#
# Quorum add component pages

require 5.005;
use strict;
use lib '/opt/SUNWscvw/lib/perl';
use Cluster::Cgi;
use Cluster::Quorum;
use Sun::Solaris::Utils qw(gettext);

# Create the html query object
my $q = new Cluster::Cgi;
# Create a quorum object
my $quorum = new Cluster::Quorum;

my $qd_name = $q->param('qd_name');
my $step = $q->param('step');

# Check if in Cluster mode
if ($quorum->is_clustermode($q) != 0) {
        # not in cluster mode
        $quorum->print_nonclustermode_error($q);
        exit;
}

# Get output of usefull commands into tmp files
$quorum->get_commandoutput();

# Print the query header
print $q->header();

# Start the document
print $q->start_html({  STYLE  => { 'src' => '/css/clustmgr-style.css'},
			TITLE  => gettext("Add Quorum Device"),
                        CLASS  => "default-body",
                        SCRIPT => $q->jump_menu_jscript() .
				    $q->yoke_jscript("q")
                });

$quorum->add_quorumdevice($q, $step, $qd_name);

# End the html document
$quorum->footer($q);
