#!/usr/perl5/bin/perl -w
#
# Copyright (c) 2001 by Sun Microsystems, Inc.
# All rights reserved.
#
#ident	"@(#)rg.pl	1.4	01/08/23 SMI"
#
# Return a list of resource groups for the Java applet

require 5.005;
use strict;
use lib '/opt/SUNWscvw/lib/perl';
use Cluster::Rg;
use Cluster::Cgi;
use Sun::Solaris::Utils qw(gettext);

# Create the html query object
my $q = new Cluster::Cgi;

# Create the RG object
my $rg = new Cluster::Rg;

# Print the html header
print $q->header(-expires => "now");

# Get the list of RGs
my @rg_list = $rg->get_rglist();

# Print the number of RGs
my $length = $#rg_list + 1;
print "$length\n";

foreach my $rg_item (@rg_list) {
    print "$rg_item\n";
}

# Get the nodelist
my @node_list = $rg->get_nodelist();

# foreach rg, print out the states on all of the nodes
foreach my $rg_item (@rg_list) {

    # Get the nodelist for this rg
    my @rg_node_list = $rg->get_rg_nodelist($rg_item);

    foreach my $node (@node_list) {

	# If this node is in the nodelist, get its state
	if (member($node, @rg_node_list) > -1) {
	    my $state = $rg->get_rg_state_node($rg_item, $node);

	    if ($state eq "ONLINE") {
		print "Online\n";  # Used internally by rg.pl; do not I18nize
	    } else {
		print "Offline\n";
	    }

	# Else, print 0
	} else {
	    print "0\n";
	}
    }
}

sub member {
    my ($item, @array) = @_;

    # Return position of element if we find it
    for (my $i = 0; $i <= $#array; $i++) {
        if ($item eq $array[$i]) {
            return $i;
        }
    }

    # return -1 if we didn't find element
    return -1;
}
