#!/usr/perl5/bin/perl -w
#
# Copyright (c) 2001 by Sun Microsystems, Inc.
# All rights reserved.
#
#ident	"@(#)scstat.pl	1.22	01/11/14 SMI"
#
# Resource group information

require 5.005;
use strict;
use lib '/opt/SUNWscvw/lib/perl';
use Cluster::common;
use Cluster::scrgcommon;
use Sun::Solaris::Utils qw(gettext);



# Internationalization is done in do_page, phrases match rg_config.pl
my @rg_link = ("Resource Groups", "/cgi-bin/rg/rg_view.pl");

&do_page({
    cmd_rgoffline => [@rg_link, "Take Group Offline"],
    cmd_rgprim => [@rg_link, "Bring Group Online"],
    cmd_rgrestart => [@rg_link, "Restart Resource Group"],
    cmd_rgunmanage => [@rg_link, "Put Group into Unmanaged State"],
    cmd_rgmanage => [@rg_link, "Put Group into Managed State"],
    cmd_rsenable => [@rg_link, "Enable Resource"],
    cmd_rsdisable => [@rg_link, "Disable Resource"],
    cmd_rsmenable => [@rg_link, "Enable Resource Monitor"],
    cmd_rsmdisable => [@rg_link, "Disable Resource Monitor"],
    cmd_rs_delete => [@rg_link, "Delete Resource"],
    cmd_rs_failed => [@rg_link, "Clear Stop-Failed Flag"],
    cmd_rs_weights => [@rg_link, "Modify Load Balancing"],
    cmd_rs_weights_1 => [@rg_link, "Modify Load Balancing"],
    cmd_rsmodify => [@rg_link, "Modify Resource Properties"],
    cmd_rsmodify2 => [@rg_link, "Modify Resource Properties"],
    cmd_rgrs_delete => [@rg_link, "Delete Resource Group"]});

exit;

# Generate $hosts from the checked hosts
sub hosts {
  my $hosts = join(",", $q->param('node'));
    if ($hosts eq "") {
      # Special "empty host list"
      $hosts = "\"\"";
    }
  return $hosts;
}

sub cmd_rgoffline {
    my ($rg, $cmd, $status);
    &wizard_start();
    &getscstatrg();
    
    $rg = $q->param("rg");
    print $q->_script($q->yoke_jscript("rg-$rg"));
    &manage_if_necessary($rg);
    $cmd = "scswitch -F -g $rg";
    $status = &runsuid($cmd);
    if ($status == 0) {
	&okmsg(gettext("Resource group taken offline"));
    } else {
	&errmsg(gettext("Failure"), $result);
    }
    &wizard_end();
    (new Cluster::Rg)->view_button($q);
}

sub cmd_rgprim {
    my ($rg, $cmd, $status, $hosts);
    &wizard_start();
    &getscstatrg();

    # Get hosts from checkboxes
    $hosts = &hosts;

    $rg = $q->param("rg");
    print $q->_script($q->yoke_jscript("rg-$rg"));
    &manage_if_necessary($rg);

    $cmd = "scswitch -z -g $rg -h $hosts";
    $status = &runsuid($cmd);
    if ($status == 0) {
	if ($hosts eq "\"\"") {
	    &okmsg(gettext("Resource group taken offline"));
	} else {
	    &okmsg(gettext("Primary switch completed successfully"));
	}
    } else {
	&errmsg(gettext("Failure"), $result);
    }
    &wizard_end();
    (new Cluster::Rg)->view_button($q);
}

sub cmd_rgrestart {
    my ($rg, $cmd, $status, $hosts);
    &wizard_start();
    &getscstatrg();
    $hosts = &hosts;
    $rg = $q->param("rg");
    print $q->_script($q->yoke_jscript("rg-$rg"));
    &manage_if_necessary($rg);
    $cmd = "scswitch -R -g $rg -h $hosts";
    $status = &runsuid($cmd);
    if ($status == 0) {
	if ($hosts eq "\"\"") {
	    &okmsg(gettext("No nodes: nothing done"));
	} else {
	    &okmsg(gettext("Restart completed successfully"));
	}
    } else {
	&errmsg(gettext("Failure"), $result);
    }
    &wizard_end();
    (new Cluster::Rg)->view_button($q);
}

sub cmd_rgunmanage {
    my ($rg, $cmd, $status);
    &wizard_start();
    &getscstatrg();
    $rg = $q->param("rg");
    print $q->_script($q->yoke_jscript("rg-$rg"));
    $cmd = "scswitch -F -g $rg";
    $status = &runsuid($cmd);
    $cmd = "scswitch -u -g $rg";
    $status = &runsuid($cmd);
    if ($status == 0) {
	&okmsg(gettext("Resource group unmanaged"));
    } else {
	&errmsg(gettext("Failure"), $result);
    }
    &wizard_end();
    (new Cluster::Rg)->view_button($q);
}

sub cmd_rgmanage {
    my ($rg, $cmd, $status);
    &wizard_start();
    &getscstatrg();
    $rg = $q->param("rg");
    print $q->_script($q->yoke_jscript("rg-$rg"));
    $cmd = "scswitch -o -g $rg";
    $status = &runsuid($cmd);
    if ($status == 0) {
	&okmsg(gettext("Resource group managed"));
    } else {
	&errmsg(gettext("Failure"), $result);
    }
    &wizard_end();
    (new Cluster::Rg)->view_button($q);
}

sub cmd_rsenable {
    my ($rs, $cmd, $status);
    &wizard_start();
    &getscstatrg();
    $rs = $q->param("rs");
    print $q->_script($q->yoke_jscript("rg-rs-$rs"));
    $cmd = "scswitch -e -j $rs";
    $status = &runsuid($cmd);
    if ($status == 0) {
	&okmsg(gettext("Resource enabled"));
    } else {
	&errmsg(gettext("Failure"), $result);
    }
    &wizard_end();
    (new Cluster::Rg)->view_button($q);
}

sub cmd_rsdisable {
    my ($rs, $cmd, $status);
    &wizard_start();
    #&getscstatrg();
    $rs = $q->param("rs");
    print $q->_script($q->yoke_jscript("rg-rs-$rs"));
    $cmd = "scswitch -n -j $rs";
    $status = &runsuid($cmd);
    if ($status == 0) {
	&okmsg(gettext("Resource disabled"));
    } else {
	&errmsg(gettext("Failure"), $result);
    }
    &wizard_end();
    (new Cluster::Rg)->view_button($q);
}

sub cmd_rsmenable {
    my ($rs, $cmd, $status);
    &wizard_start();
    #&getscstatrg();
    $rs = $q->param("rs");
    print $q->_script($q->yoke_jscript("rg-rs-$rs"));
    $cmd = "scswitch -e -M -j $rs";
    $status = &runsuid($cmd);
    if ($status == 0) {
	&okmsg(gettext("Resource monitoring enabled"));
    } else {
	&errmsg(gettext("Failure"), $result);
    }
    &wizard_end();
    (new Cluster::Rg)->view_button($q);
}

sub cmd_rsmdisable {
    my ($rs, $cmd, $status);
    &wizard_start();
    #&getscstatrg();
    $rs = $q->param("rs");
    print $q->_script($q->yoke_jscript("rg-rs-$rs"));
    $cmd = "scswitch -n -M -j $rs";
    $status = &runsuid($cmd);
    if ($status == 0) {
	&okmsg(gettext("Resource monitoring disabled"));
    } else {
	&errmsg(gettext("Failure"), $result);
    }
    &wizard_end();
    (new Cluster::Rg)->view_button($q);
}
# -----------------------

sub cmd_rs_delete {
    my ($cmd, $status);

    print $q->_script($q->yoke_jscript("rg-rs-".$q->param("rs")));
    $cmd = "scswitch -n -j ".$q->param("rs");
    $status = &runsuid($cmd);
    if ($status == 0) {
	print gettext("Resource disabled.\n");
    } else {
	&errmsg(gettext("Resource disable failed.\n"));
	$result =~ s/scswitch: //;
	print "$result";
	if ($result =~ /depends upon/) {
	    return;
	}
    }
    $cmd = "scrgadm -r -j ".$q->param("rs");
    $status = &runsuid($cmd);
    if ($status == 0) {
	&okmsg(gettext("Resource deleted successfully"));
	&reloadmenu($q);
	print $q->_script($q->yoke_jscript("rg"));
    } else {
	if ($result =~ /invalid/) {
	    &errmsg(gettext("That resource does not exist in the cluster"));
	} else {
	    &errmsg(gettext("Failure"));
	}
    }
    &wizard_end();
    (new Cluster::Rg)->view_button($q);
}

# Clear the stop failed flag
sub cmd_rs_failed {
    my $nodelist = "";

    &getscstatrg();
    print $q->_script($q->yoke_jscript("rg-rs-".$q->param("rs")));
    &getnodes;
    my $j;
    my $failed = 0;
    for ($j = 0; $j <= $#nodes; $j++) {
	if ($rsstate{$q->param("rs"), $nodes[$j]} =~ /stop failed/i) {
	    if ($nodelist) {
		$nodelist = join(",", $nodelist, $nodes[$j]);
	    } else {
		$nodelist = $nodes[$j];
	    }
	}
    }

    if ($nodelist eq "") {
	&errmsg(sprintf(gettext("Resource %s not in stop failed state"), $q->param("rs")));
	&wizard_end();
	(new Cluster::Rg)->view_button($q);
	return;
    }

    my ($cmd, $status);

    $cmd = "scswitch -c -h $nodelist -j ".$q->param("rs")." -f STOP_FAILED";
    $status = &runsuid($cmd);
    if ($status == 0) {
	print gettext("Flag cleared.\n");
	print "<br>\n";
    } else {
	&errmsg(gettext("scswitch failed.\n"));
    }
    &wizard_end();
    (new Cluster::Rg)->view_button($q);
}

# Update load balancer weights
#
# Note: this command also causes the loadbalance_script
# to be printed in the header of the file, before this
# function is called to print the body. See common.pm
# That javascript calculates percentage values for weights
sub cmd_rs_weights {
    my ($cmd, $status);
    &wizard_start();
    print $q->_script($q->yoke_jscript("rg-rs-".$q->param("rs")));

    undef %Cluster::scrgcommon::rsprops;
    &getrsprops($q->param("rs"));
    &getrgprops($rsrg{$q->param("rs")});
    my $weightstring = $rsprops{"Load_balancing_weights"};
    my @oknodes = split(/ /, $rgprops{"Nodelist"});

    if (! defined($weightstring) || $#oknodes < 0) {
	&errmsg(gettext("The resource does not have weights."));
	&wizard_end();
	(new Cluster::Rg)->view_button($q);
	exit;
    }
    if ($errpos == 1) {
	&errmsg;
    }

    # Begin "Weights" table:
    print $q->start_table({	CLASS => "action-table",
				CELLSPACING	=> 0,
				BORDER		=> 0,
				CELLPADDING	=> 5,
			  });

    # Print resource name row:
    print $q->start_Tr(), $q->start_td();
    print $q->CGI::div({CLASS   => "action-window-label-text"},
		       gettext("Resource Name:")
		      );
    print $q->end_td(), "\n";
    print $q->start_td({        WIDTH      => 2,
		       });
    print "&nbsp;";
    print $q->end_td(), "\n";
    print $q->start_td({        COLSPAN    => 3 });
    print $q->CGI::div({        CLASS      => 
				"action-window-table-noindent-text"},
		       $q->param("rs")
		       . "&nbsp;&nbsp;&nbsp;("
		       . $rsrg{$q->param("rs")} . ")"
		      );
    print $q->end_td(), "\n";
    print $q->end_Tr();

    #` Print outer table header row:
    print $q->start_Tr(), $q->start_td();
    print $q->CGI::div({             CLASS      => "action-window-label-text"},
		  gettext("Load Balancing Weights:")
		 );
    print $q->end_td();
    print $q->start_td({        WIDTH      => 2,
				COLSPAN    => 4,
		       });
    print "&nbsp;";
    print $q->end_td(), "\n";
    print $q->end_Tr();

    # Print inner table header row:
    print $q->start_Tr();
    print $q->start_td({        WIDTH      => 2,
				COLSPAN    => 2,
		       });
    print "&nbsp;";
    print $q->end_td(), "\n";
    print $q->start_td();
    print $q->CGI::div({        CLASS      => 
				"action-window-table-noindent-text"},
		       gettext("Weight"));
    print $q->end_td(), "\n";    
    print $q->start_td({        WIDTH      => 2,
		       });
    print "&nbsp;";
    print $q->end_td(), "\n";
    print $q->start_td();  
    print $q->CGI::div({        CLASS      => 
				"action-window-table-noindent-text"},
		       gettext("Load Distribution"));
    print $q->end_td(), "\n";
    print $q->end_Tr();


    &getnodes();
    my $i;
    my @weights;
    my @nodeweight;
    if ($weightstring eq "<NULL>") {
	$weightstring = "";
    }
    @weights = split(/,/, $weightstring);
    for ($i = 0; $i <= $#weights; $i++) {
	my ($weight, $node);
	($weight, $node) = split(/@/, $weights[$i]);
	if ($node =~ /^\d+$/) {
	    # Node specified as a digit
	} else {
	    # Node specified as a name; look it up in node list
	    for ($node = 0; $node <= $#nodes; $node++) {
		if ($nodes[$i] eq $node) {
		    last;
		}
	    }
	    if ($node > $#nodes) {
		&errmsg(gettext("Couldn't parse weight string"));
	    } else {
		$node++;
	    }
	}
	$q->param("weight".$node, $weight);
    }
    
    # Print weight/percent table:
    for ($i = 0; $i <= $#oknodes; $i++) {
      print $q->start_Tr();
	print $q->start_td({        ALIGN      => "right",
			   });
	print $q->CGI::div({CLASS => "action-window-normal-table-text"},
			   sprintf(gettext("%s:"), $nodes[$i]));
	print $q->end_td(), "\n";
	print $q->start_td({        WIDTH      => 2,
			   });
	print "&nbsp;";
	print $q->end_td(), "\n";
	print $q->start_td();
	my $i1 = $i+1;

	print $q->CGI::div({CLASS=> "action-window-table-noindent-text"},
			   $q->textfield(
					 { NAME	 => "weight$i1",
				     SIZE	 => 5,
				     DEFAULT	 => 1,
				     onChange    => "calcLoadPercent()",
				     onKeyUp     => "calcLoadPercent()",
				     onBlur      => "calcLoadPercent()",
				   }
					)
			  );
	print $q->end_td(), "\n";

	print $q->start_td({        WIDTH      => 2,
			   });
	print "&nbsp;";
	print $q->end_td(), "\n";
	print $q->start_td();
	print $q->CGI::div({CLASS=> "action-window-table-noindent-text"},
			   $q->textfield(
			       { NAME	     => "percent$i1",
				 SIZE	     => 5,
				 DEFAULT     => "",
				 onChange    => "calcLoadPercent()",
				 readonly    => undef,
				 onFocus     => "this.blur()",
				 tabindex    => -1,
			       }
					)
			  );
	print $q->end_td(), $q->end_Tr(), "\n";
    }
    print $q->end_table(), "\n";



    # Begin "Weights" table:
    print $q->start_table({	CLASS => "action-table",
				CELLSPACING	=> 0,
				BORDER		=> 0,
				CELLPADDING	=> 0,
				ALIGN           => "center",
				WIDTH           => "97%",
				}
);

    # Print resource name row:
    print $q->start_Tr({  HEIGHT    => 15,});
    print $q->start_td();
    print $q->img({ SRC             => "/images/dot.gif",
		    ALT             => "",
		    HEIGHT          => 1,
		    WIDTH           => 1,
		  });
    print $q->end_td();
    print $q->end_Tr();
    print $q->start_Tr({  HEIGHT    => 1,});
    print $q->start_td({  CLASS     => "action-line-row", });
    print $q->img({ SRC             => "/images/dot.gif",
		    ALT             => "",
		    HEIGHT          => 1,
		  });
    print $q->end_td();
    print $q->end_Tr();
    print $q->start_Tr({  HEIGHT    => 6,});
    print $q->start_td({  HEIGHT    => 5,});
    print $q->img({ SRC             => "/images/dot.gif",
		    ALT             => "",
		    HEIGHT          => 6,
		  });
    print $q->end_td();
    print $q->end_Tr();
    print $q->start_Tr();
    print $q->start_td({  ALIGN     => "right",});
    &hidden("rs");
    &hidden("rg");
    &submit("cmd_rs_weights_1", gettext("   Modify Load Balancing   "));
    print $q->button({    NAME      => "Cancel",
		          VALUE     => gettext("   Cancel   "),
		          onClick   => "history.back()",
		     });
    print $q->end_td();
    print $q->end_Tr();
    print$q->end_table();


    &wizard_end();
    
}

sub cmd_rs_weights_1 {
    my $i;
    &wizard_start();
    print $q->_script($q->yoke_jscript("rg-rs-".$q->param("rs")));
    my $weights = "";
    my $weight_sum = 0;
    my @node_weights = (0);

    foreach $i (sort $q->param()) {
      if ($i =~ /^weight(\d+)/) {
	my $node = $1;

	if ($weights) {
	  $weights .= ",";
	}

	if ($q->param($i) =~ /^\d+$/) {
	  $weights .= $q->param($i)."\@$node";
	  $node_weights[$node] = $q->param($i);
	  $weight_sum += $q->param($i);

	} elsif ($q->param($i) =~ /^$/) {
	  # ignore empty parameters without complaining
	} else {
	  &errpage(sprintf(gettext("Bad weight %s"), $q->param($i)),
		   1,
		   "cmd_rs_weights"
		  );
	}
      }
    } # foreach

    if ($weights eq "") {
	&errmsg(gettext("No weights specified"));
	return;
    }

    my $cmd = "scrgadm -c -j ".$q->param("rs")." -y Load_balancing_weights=$weights";
    my $status = &runsuid($cmd);
    if ($status) {
	&errmsg(gettext("Failure"));
    } else {
	my $summary = $q->CGI::div({  CLASS => "message-description-text"},
		     gettext("The approximate load distribution will be:")
				  );

	&getnodes();
	for (my $i = 1; $i <= $#node_weights; $i++){
	  my $percent = 0;
	  my $percent_str = "";
	  if ($weight_sum > 0) {
	    $percent =  100 * $node_weights[$i] / $weight_sum;
	    $percent_str = sprintf("%3.0f", $percent);
	  }
	  $summary = $summary
	    . $q->CGI::div({CLASS       => "message-description-text"},
			   $nodes[$i-1] 
			   . ":  " 
			   . $percent_str . "%"
			  );
	} # for
	&okmsg(gettext("Resource Load Balancing Successfully Modified") 
	       . $summary);
      }

    &wizard_end();
    (new Cluster::Rg)->view_button($q);
}

# Move the resource group into managed state if it isn't managed
sub manage_if_necessary {
    my ($rg) = @_;
    &getrgprops($rg);

    if ($rgprops{"management state"} eq "Unmanaged") {
	my ($cmd, $status);
	$cmd = "scswitch -o -g $rg";
	$status = &runsuid($cmd);
	if ($status == 0) {
	} else {
	    &errmsg(gettext("Failure"), $result);
	}
    }
}

sub cmd_rsmodify {
    my ($rs, $cmd, $status);
    &wizard_start();
    print $q->_script($q->yoke_jscript("rg-rs-".$q->param("rs")));
    &getscstatrg();
    &getscrgconfig();
    &getrsprops($q->param("rs"));
    &action_table_start();

    # Print the resource name
    print $q->start_Tr();
    print $q->start_td();
    $q->start_table_text("action-window-label-text");
    print gettext("Resource Name:");
    $q->end_table_text();
    print $q->end_td();
    print $q->start_td();
    $q->start_table_text("action-window-table-normal-text");
    print $q->param("rs");
    $q->end_table_text();
    print $q->end_td();
    print $q->end_Tr();

    &action_table_row_start("R_description</div><br><div>".gettext("A brief description of the resource"));
    $FORM{"prop_R_description"} = $rsprops{"R_description"};
    &input("prop_R_description");
    &action_table_row_start("Resource_dependencies</div><br><div>".gettext("List of strong resource dependencies"));
    $FORM{"prop_Resource_dependencies"} = $rsprops{"strong dependencies"};
    &input("prop_Resource_dependencies");
    &action_table_row_start("Resource_dependencies_weak</div><br><div>".gettext("List of weak resource dependencies"));
    $FORM{"prop_Resource_dependencies_weak"} = $rsprops{"weak dependencies"};
    &input("prop_Resource_dependencies_weak");


    $q->param("rt", $rsrt{$q->param("rs")});
    $FORM{"rt"} = $rsrt{$q->param("rs")};
    $q->param("allparams", 1);
    $FORM{"allparams"} = 1;
    &proptable(1, "");
    &action_table_end();

    print $q->hidden({NAME => "cmd_rsmodify2", VALUE => 1});
    (new Cluster::Rg)->submit_button($q, gettext(" Modify Resource "),
	"cancel");

    &hidden("rt");
    &hidden("rs");
    &hidden("rg");
    &wizard_end();
}

sub cmd_rsmodify2 {

    &wizard_start;
    print $q->_script($q->yoke_jscript("rg-rs-".$q->param("rs")));
    &getscrgconfig();
    &getrsprops($q->param("rs"));
    &getrtprops($q->param("rt"));

    # Properties not included in rttable
    $rttable{"R_description", "extension"} = "False";
    $rttable{"Resource_dependencies", "extension"} = "False";
    $rttable{"Resource_dependencies_weak", "extension"} = "False";
    $rsprops{"Resource_dependencies"} = $rsprops{"strong dependencies"};
    $rsprops{"Resource_dependencies_weak"} = $rsprops{"weak dependencies"};

    my $args;
    my $status;
    my ($lh, $lhrg, $lhrs, $lhmode) = split(/:/, $q->param("lh"));
    my $mode = $q->param("mode");

    my $cmd;

    $cmd = "scrgadm -c -j ".$q->param("rs");
    my $i;
    my ($changed) = 0;
    foreach $i (keys %FORM) {
	if ($i =~ /^prop_(.*)/) {
	    my $prop = $1;

	    # Handle null strings properly
	    if ($q->param($i) eq "NULL" || $q->param($i) eq "<NULL>") {
		$q->param($i, "");
	    }
	    if ($rsprops{$prop} eq "NULL" || $rsprops{$prop} eq "<NULL>") {
		$rsprops{$prop} = "";
	    }

	    if (! defined $rttable{$prop, "extension"}) {
		# Property isn't defined in the rt
		&errmsg(sprintf(gettext("Unknown property %s"), $prop));
		next;
	    } elsif ($rttable{$prop, "extension"} eq "True") {
		if (lc($q->param($i)) ne lc($rsprops{$prop})) {
		    if ($q->param($i) =~ / /) {
			$cmd .= " -x $prop=\"".$q->param($i)."\"";
		    } else {
			$cmd .= " -x $prop=".$q->param($i);
		    }
		    $changed = 1;
		}
	    } elsif ($rttable{$prop, "extension"} eq "False") {
		if (lc($q->param($i)) ne lc($rsprops{$prop})) {
		    if ($q->param($i) =~ / /) {
			$cmd .= " -y $prop=\"".$q->param($i)."\"";
		    } else {
			$cmd .= " -y $prop=".$q->param($i);
		    }
		    $changed = 1;
		}
	    } else {
		&errmsg(sprintf(gettext("Unknown property %s"), $prop));
		next;
	    }
	}
    }

    if ($changed == 0) {
	&errmsg(gettext("Nothing changed"));
	&wizard_end();
	(new Cluster::Rg)->view_button($q);
	return;
    }

    $status = &runsuid($cmd);
    if ($status) {
	# Arbitrary error result; can't i18n
	&errmsg(gettext("Failure"), $result);
    } else {
	&okmsg(gettext("Resource updated"));
    }
    &wizard_end();
    (new Cluster::Rg)->view_button($q);
}

# Delete resource group and all resources in it
sub cmd_rgrs_delete {
    my ($cmd, $status);
    &wizard_start(gettext("Remove Resource Group and Resources"), "scrgadm.pl");
    print $q->_script($q->yoke_jscript("rg"));
    &getscrgconfig();
    my $rs;
    foreach $rs (keys %rsrg) {
	if ($rsrg{$rs} eq $FORM{"rg"}) {
	    $cmd = "scswitch -n -j $rs";
	    $status = &runsuid($cmd);
	    if ($status) {
		&errmsg(sprintf(gettext("Failed to disable %s"), $rs)."<br>$result");
	    }
	    $cmd = "scrgadm -r -j $rs";
	    $status = &runsuid($cmd);
	    if ($status) {
		&errmsg(sprintf(gettext("Failed to delete %s"), $rs)."<br>$result");
	    }
	}
    }
    $cmd = "scrgadm -r -g ".$FORM{"rg"};
    $status = &runsuid($cmd);
    if ($status == 0) {
	&okmsg(gettext("Resource group deleted successfully"));
	&reloadmenu($q);
    } else {
	if ($result =~ /invalid/) {
	    &errmsg(gettext("That resource group does not exist in the cluster"));
	} else {
	    &errmsg(gettext("Failure"), $result);
	}
    }
    &wizard_end();
    (new Cluster::Rg)->view_button($q);
}

sub cmd_mainpage {
    # Redirect to Resource Group page
    print $q->script(),"\n";
    print "document.location=\"$rg_link[1]\";\n";
    print $q->end_script(),"\n";
}
